delimiter //

-- смержить группы
DROP FUNCTION IF EXISTS MergeGroups//
CREATE FUNCTION `MergeGroups` (
    `srcGroup` INT,
    `dstGroup` INT
) RETURNS INT
BEGIN
    UPDATE IGNORE disciplines_groups
        SET disciplines_groups.GroupID = dstGroup
        WHERE disciplines_groups.GroupID = srcGroup;

    UPDATE IGNORE students_groups
        SET students_groups.GroupID = dstGroup
        WHERE students_groups.GroupID = srcGroup;

    UPDATE IGNORE logs_binds_groups
        SET logs_binds_groups.GroupID = dstGroup
        WHERE logs_binds_groups.GroupID = srcGroup;

    delete from disciplines_groups
        where disciplines_groups.GroupID = srcGroup;
    delete from students_groups
        where students_groups.GroupID = srcGroup;
    delete from logs_binds_groups
        where logs_binds_groups.GroupID = srcGroup;


    delete from study_groups
        where id = srcGroup;

    return 0;
END//

DELIMITER ;

-- список потенциальных дубликатов
select  count(*) as cntGroups,
        GROUP_CONCAT(view_groups.groupid SEPARATOR  ',') as groupsIds,
        GROUP_CONCAT(view_groups.SpecName SEPARATOR  ',') as groupsSpecs,
        view_groups.*
from view_groups
group by gradeid, groupNum, FacultyID
having count(*) > 1

-- смерджить список потенциальных дубликатов
drop table if exists tGroupMergeTable;
CREATE TEMPORARY TABLE tGroupMergeTable as (
    select  view_groups.groupid as src,
            BaseGroups.dst as dst
    from (
        select min(groupid) as dst, gradeid, groupNum, FacultyID
        from view_groups
        group by gradeid, groupNum, FacultyID
        having count(*) > 1
    ) as BaseGroups
    left join view_groups on    view_groups.gradeid = BaseGroups.gradeid and
                                view_groups.groupNum = BaseGroups.groupNum and
                                view_groups.FacultyID = BaseGroups.FacultyID and
                                view_groups.groupid != BaseGroups.dst
);

select *
from tGroupMergeTable;

select MergeGroups(src, dst)
from tGroupMergeTable;


-- удаление специализаций, к которым не привязана ни одна группа
delete from specializations
    where id not in (
        select study_groups.SpecializationID from study_groups
    )
